/// <reference types="bn.js" />
import { Transaction } from "@solana/web3.js";
import { BN } from "@project-serum/anchor";
import { Context, PDA } from "..";
export declare class StakingClient {
    ctx: Context;
    pda: PDA;
    constructor(ctx: Context, pda: PDA);
    stake(amount: BN): Promise<Transaction>;
    withdraw(amount: BN, index: number): Promise<Transaction>;
    withdrawAfterDelay(index: number): Promise<Transaction>;
    claim(): Promise<Transaction>;
    lockup(amount: BN, index: number, vaultIndex: number): Promise<Transaction>;
    unlock(index: number, vaultIndex: number): Promise<Transaction>;
}
